# This Python file uses the following encoding: utf-8
"""autogenerated by genpy from digitaleye_msgs/Booking.msg. Do not edit."""
import codecs
import sys
python3 = True if sys.hexversion > 0x03000000 else False
import genpy
import struct

import digitaleye_msgs.msg

class Booking(genpy.Message):
  _md5sum = "26427d3bb5904a383015921ee19b49ea"
  _type = "digitaleye_msgs/Booking"
  _has_header = False  # flag to mark the presence of a Header object
  _full_text = """# Booking

# booking id
uint32 booking_id

# status of booking use booking constants STATUS_
uint32 status

# agent registration linked to the booking
uint64 agent_reg

# actions linked to booking
digitaleye_msgs/Action[] actions

================================================================================
MSG: digitaleye_msgs/Action
# Action definition

# action id
uint32 id

# action for the following entity(ies) id (can be empty)
uint64[] entity_id

# start time of allocation (included) (Epoch timestamp in seconds)
uint64 start

# end time of allocation (included) (Epoch timestamp in seconds)
uint64 end

# category of action, use ACTION_CAT_
uint32 category

uint32 ACTION_CAT_WALK = 0
uint32 ACTION_CAT_AIR_ENTRY = 1
uint32 ACTION_CAT_AIR_EXIT = 2
uint32 ACTION_CAT_GROUND_ENTRY = 3
uint32 ACTION_CAT_GROUND_EXIT = 4
uint32 ACTION_CAT_FLIGHT_IN = 5
uint32 ACTION_CAT_FLIGHT_OUT = 6
uint32 ACTION_CAT_GROUND_IN = 7
uint32 ACTION_CAT_GROUND_OUT = 8
uint32 ACTION_CAT_GROUND_AIR_DELIV = 9

# action dependencies
uint32[] action_dep
"""
  __slots__ = ['booking_id','status','agent_reg','actions']
  _slot_types = ['uint32','uint32','uint64','digitaleye_msgs/Action[]']

  def __init__(self, *args, **kwds):
    """
    Constructor. Any message fields that are implicitly/explicitly
    set to None will be assigned a default value. The recommend
    use is keyword arguments as this is more robust to future message
    changes.  You cannot mix in-order arguments and keyword arguments.

    The available fields are:
       booking_id,status,agent_reg,actions

    :param args: complete set of field values, in .msg order
    :param kwds: use keyword arguments corresponding to message field names
    to set specific fields.
    """
    if args or kwds:
      super(Booking, self).__init__(*args, **kwds)
      # message fields cannot be None, assign default values for those that are
      if self.booking_id is None:
        self.booking_id = 0
      if self.status is None:
        self.status = 0
      if self.agent_reg is None:
        self.agent_reg = 0
      if self.actions is None:
        self.actions = []
    else:
      self.booking_id = 0
      self.status = 0
      self.agent_reg = 0
      self.actions = []

  def _get_types(self):
    """
    internal API method
    """
    return self._slot_types

  def serialize(self, buff):
    """
    serialize message into buffer
    :param buff: buffer, ``StringIO``
    """
    try:
      _x = self
      buff.write(_get_struct_2IQ().pack(_x.booking_id, _x.status, _x.agent_reg))
      length = len(self.actions)
      buff.write(_struct_I.pack(length))
      for val1 in self.actions:
        _x = val1.id
        buff.write(_get_struct_I().pack(_x))
        length = len(val1.entity_id)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(struct.Struct(pattern).pack(*val1.entity_id))
        _x = val1
        buff.write(_get_struct_2QI().pack(_x.start, _x.end, _x.category))
        length = len(val1.action_dep)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(struct.Struct(pattern).pack(*val1.action_dep))
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize(self, str):
    """
    unpack serialized message in str into this message instance
    :param str: byte array of serialized message, ``str``
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.actions is None:
        self.actions = None
      end = 0
      _x = self
      start = end
      end += 16
      (_x.booking_id, _x.status, _x.agent_reg,) = _get_struct_2IQ().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.actions = []
      for i in range(0, length):
        val1 = digitaleye_msgs.msg.Action()
        start = end
        end += 4
        (val1.id,) = _get_struct_I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.entity_id = s.unpack(str[start:end])
        _x = val1
        start = end
        end += 20
        (_x.start, _x.end, _x.category,) = _get_struct_2QI().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.action_dep = s.unpack(str[start:end])
        self.actions.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill


  def serialize_numpy(self, buff, numpy):
    """
    serialize message with numpy array types into buffer
    :param buff: buffer, ``StringIO``
    :param numpy: numpy python module
    """
    try:
      _x = self
      buff.write(_get_struct_2IQ().pack(_x.booking_id, _x.status, _x.agent_reg))
      length = len(self.actions)
      buff.write(_struct_I.pack(length))
      for val1 in self.actions:
        _x = val1.id
        buff.write(_get_struct_I().pack(_x))
        length = len(val1.entity_id)
        buff.write(_struct_I.pack(length))
        pattern = '<%sQ'%length
        buff.write(val1.entity_id.tostring())
        _x = val1
        buff.write(_get_struct_2QI().pack(_x.start, _x.end, _x.category))
        length = len(val1.action_dep)
        buff.write(_struct_I.pack(length))
        pattern = '<%sI'%length
        buff.write(val1.action_dep.tostring())
    except struct.error as se: self._check_types(struct.error("%s: '%s' when writing '%s'" % (type(se), str(se), str(locals().get('_x', self)))))
    except TypeError as te: self._check_types(ValueError("%s: '%s' when writing '%s'" % (type(te), str(te), str(locals().get('_x', self)))))

  def deserialize_numpy(self, str, numpy):
    """
    unpack serialized message in str into this message instance using numpy for array types
    :param str: byte array of serialized message, ``str``
    :param numpy: numpy python module
    """
    if python3:
      codecs.lookup_error("rosmsg").msg_type = self._type
    try:
      if self.actions is None:
        self.actions = None
      end = 0
      _x = self
      start = end
      end += 16
      (_x.booking_id, _x.status, _x.agent_reg,) = _get_struct_2IQ().unpack(str[start:end])
      start = end
      end += 4
      (length,) = _struct_I.unpack(str[start:end])
      self.actions = []
      for i in range(0, length):
        val1 = digitaleye_msgs.msg.Action()
        start = end
        end += 4
        (val1.id,) = _get_struct_I().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sQ'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.entity_id = numpy.frombuffer(str[start:end], dtype=numpy.uint64, count=length)
        _x = val1
        start = end
        end += 20
        (_x.start, _x.end, _x.category,) = _get_struct_2QI().unpack(str[start:end])
        start = end
        end += 4
        (length,) = _struct_I.unpack(str[start:end])
        pattern = '<%sI'%length
        start = end
        s = struct.Struct(pattern)
        end += s.size
        val1.action_dep = numpy.frombuffer(str[start:end], dtype=numpy.uint32, count=length)
        self.actions.append(val1)
      return self
    except struct.error as e:
      raise genpy.DeserializationError(e)  # most likely buffer underfill

_struct_I = genpy.struct_I
def _get_struct_I():
    global _struct_I
    return _struct_I
_struct_2IQ = None
def _get_struct_2IQ():
    global _struct_2IQ
    if _struct_2IQ is None:
        _struct_2IQ = struct.Struct("<2IQ")
    return _struct_2IQ
_struct_2QI = None
def _get_struct_2QI():
    global _struct_2QI
    if _struct_2QI is None:
        _struct_2QI = struct.Struct("<2QI")
    return _struct_2QI
